﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace CustomIndicator
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }
    }

    public class TestingValues
    {
        public DateTime X { get; set; }
        public double High { get; set; }
        public double Low { get; set; }
        public double Open { get; set; }
        public double Close { get; set; }
    }

    public class IndicatorValue
    {
        public DateTime XValue { get; set; }

        public double? YValue { get; set; }
    }

    public class TestingValuesCollection
    {
        public TestingValuesCollection()
        {
            this.IndicatorValues = new ObservableCollection<IndicatorValue>();
            this.ChartData = new ObservableCollection<TestingValues>();
            int period = 15;
            Random rd = new Random();
            DateTime _dt = new DateTime(2015, 1, 1);

            for (int i = 0; i < 100; i++)
            {
                this.ChartData.Add(new TestingValues()
                {
                    X = _dt.AddDays(i),
                    High = rd.Next(50, 60),
                    Low = rd.Next(10, 20),
                    Open = rd.Next(20, 50),
                    Close = rd.Next(30, 50)
                });
            }
            CalculateMovingAverage(period);
        }

        // Custom Indicator logic and calculation.
        private void CalculateMovingAverage(int period)
        {
            var sum = 0.0;
            var limit = ChartData.Count;
            var length = period;
            for (var i = 0; i < length; i++)
                IndicatorValues.Add(new IndicatorValue() { XValue = ChartData[i].X, YValue = double.NaN });
            for (var i = 0; i < limit; ++i)
            {
                if (i >= length - 1 && i < limit)
                {
                    if (i - length >= 0)
                    {
                        sum += ChartData[i].Close - ChartData[i - length].Close;
                    }
                    else
                    {
                        sum += ChartData[i].Close;
                    }
                    IndicatorValues.Add(new IndicatorValue() { XValue = ChartData[i].X, YValue = (sum / length) });
                }

                else
                {
                    if (i < length - 1)
                        sum += ChartData[i].Close;
                }
            }
        }

        public ObservableCollection<TestingValues> ChartData { get; set; }

        public ObservableCollection<IndicatorValue> IndicatorValues { get; set; }
    }
}
